import { isTimeFormatFieldDef } from '../../channeldef';
import { ScaleType } from '../../scale';
import { keys } from '../../util';
import { timeFormatExpression } from '../common';
import { normalizeTimeUnit } from '../../timeunit';
export function labels(model, channel, specifiedLabelsSpec) {
    var _a, _b;
    const fieldDef = (_a = model.fieldDef(channel)) !== null && _a !== void 0 ? _a : (channel === 'x' ? model.fieldDef('x2') : channel === 'y' ? model.fieldDef('y2') : undefined);
    const axis = model.axis(channel);
    let labelsSpec = {};
    // We use a label encoding instead of setting the `format` property because Vega does not let us determine how the format should be interpreted.
    if (isTimeFormatFieldDef(fieldDef)) {
        const isUTCScale = model.getScaleComponent(channel).get('type') === ScaleType.UTC;
        const expr = timeFormatExpression('datum.value', (_b = normalizeTimeUnit(fieldDef.timeUnit)) === null || _b === void 0 ? void 0 : _b.unit, axis.format, null, isUTCScale);
        if (expr) {
            labelsSpec.text = { signal: expr };
        }
    }
    labelsSpec = Object.assign(Object.assign({}, labelsSpec), specifiedLabelsSpec);
    return keys(labelsSpec).length === 0 ? undefined : labelsSpec;
}
//# sourceMappingURL=encode.js.map